unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TControl_Panel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText1: TStaticText;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    Button4: TButton;
    ColorIndicator: TImage;
    ColorDialog1: TColorDialog;
    procedure ClearImage(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure ChangeColor(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph2D_Bezi;

{$R *.DFM}

procedure TControl_Panel.ClearImage(Sender: TObject);
begin
 Draw2D.ClearImage(255,255,255);
 index:=-1;
end;

procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;Halt;
end;

procedure TControl_Panel.ChangeColor(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    Draw2D.Blue:=ColorDialog1.Color div (256*256);
    Draw2D.Green:=(ColorDialog1.Color - 256*256*Draw2D.Blue) div 256;
    Draw2D.Red:=ColorDialog1.Color - 256*256*Draw2D.Blue - 256*Draw2D.Green;
  end;
  ColorIndicator.Canvas.Pen.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Brush.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Rectangle(0,0,ColorIndicator.Width,ColorIndicator.Height);
end;

end.
